{Copyright Bloodshed Software
 Please send feedback to: bloodshed@earthcorp.com
 http://bloodshed-software.home.ml.org/ }

unit Shareware;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Registry;

type
  TShareware = class(TComponent)
  private
  FParentForm: TForm;
  FNumberOfDay: Integer;
    { Dclarations prives }
  protected
    { Dclarations protges }
  public
   constructor Create(AOwner: TComponent); override;
   procedure Execute;
    { Dclarations publiques }
  published
   property NumberOfDay: Integer read FNumberOfDay write FNumberOfDay;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Bloodshed', [TShareware]);
end;

constructor TShareware.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  if AOwner is TForm then FParentForm := TForm(AOwner) else
    begin
    Application.MessageBox('TShareware can only be placed in a form', 'Error', mb_OK);
    Fail;
    end;
  {Default value of the number of days the user is allowed to use the software}
  FNumberOfDay:= 30;
  NumberOfDay:= FNumberOfDay;
end;

procedure TShareware.Execute;
var
  KeyHandle: HKEY;
  Expired: Boolean;
  ExpireDate: TDateTime;
  ValSize: longint;
begin

  Expired := false;
  { default expire date is the next 30 days }
  ExpireDate := Date + NumberofDay;

  { open registry... }
  { read/write the key from/to "secret" key }
  { in this case, Windows' global registry key! }
  RegOpenKeyEx(HKEY_CURRENT_CONFIG,
    'Software\Microsoft\windows\CurrentVersion\',
    0, KEY_ALL_ACCESS, KeyHandle);

  { query "secret" values... }
  ValSize := SizeOf(Expired);
  RegQueryValueEx(KeyHandle,'WinD', nil, nil, @Expired,
    @ValSize);
  ValSize := SizeOf(ExpireDate);
  RegQueryValueEx(KeyHandle,'WinE', nil, nil, @ExpireDate,
    @ValSize);

  { is Expire date >= today? }
  if Date >= ExpireDate then
  Expired := True;

  { set back "secret" values }
  { query "secret" values... }
  RegSetValueEx(KeyHandle,'WinD', 0, REG_BINARY, @Expired,  SizeOf(Expired));
  RegSetValueEx(KeyHandle,'WinE', 0, REG_BINARY, @ExpireDate, SizeOf(ExpireDate));

  { don't forget to CLOSE it!!! }
  RegCloseKey(KeyHandle);

  { has this program expired? }
  if Expired then
  begin
    MessageDlg('Sorry. ' +
      'This software has expired the ' +
        FormatDateTime('dddddd', ExpireDate) + '. ' +
      'Please register it!',
      mtInformation, [mbOK], 0);

    { Bye Bye! }
    Application.Terminate;
  end
  else
  { notify the expire date }
  MessageDlg('This software will expired on ' +
    FormatDateTime('dddddd', ExpireDate),
    mtWarning, [mbOK], 0);

end;

end.
